> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.icepanel.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.icepanel.io/_mcp/server.

# Search

GET https://api.icepanel.io/v1/landscapes/{landscapeId}/versions/{versionId}/search

Search the entire landscape

Reference: https://developer.icepanel.io/api-reference/landscapes/search

## Authentication

- `X-API-Key` header (required) — API key authentication
- `Authorization` header (bearer token, required) — Bearer token authentication

## Request

### Path parameters

- `landscapeId` (string, required)
- `versionId` (string, required)

### Query parameters

- `search` (string, required)
- `filter` (SearchFilter, optional)
- `includeData` (boolean, optional)
- `maxResults` (double, optional)

## Response

### 200

OK

- `results` (list of SearchResult, required)

## Errors

### 400 Bad Request Error

Bad Request

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 401 Unauthorized Error

Unauthorized

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 403 Forbidden Error

Forbidden

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 404 Not Found Error

Not Found

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 422 Unprocessable Entity Error

Unprocessable Entity

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 429 Too Many Requests Error

Resource Exhausted

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 500 Internal Server Error

Internal Server

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

## Types

### SearchFilter

- `type` (SearchFilterType, optional)

### SearchResult

- `id` (string, required)
- `name` (string, required)
- `score` (double, required)
- `type` (enum, required)
  - Allowed values: `actor`, `app`, `component`, `group`, `root`, `store`, `system`, `app-diagram`, `component-diagram`, `context-diagram`, `connection`, `flow`
- `data` (SearchResultData, optional)

### SearchFilterType

- enum
  - Allowed values: `actor`, `app`, `component`, `group`, `root`, `store`, `system`, `app-diagram`, `component-diagram`, `context-diagram`, `connection`, `flow`
- list of enum
  - Allowed values: `actor`, `app`, `component`, `group`, `root`, `store`, `system`, `app-diagram`, `component-diagram`, `context-diagram`, `connection`, `flow`

### SearchResultData

- ModelObject
- ModelConnection
- Diagram
- Flow

### ModelObject

- `commit` (double, required)
- `external` (boolean, required)
- `groupIds` (list of string, required) — IDs of the groups this model object belongs to
- `icon` (ModelObjectIcon, required, nullable)
- `labels` (map from string to string, required) — Generic key value store used for creating custom integrations
- `links` (map from string to RealityLink, required)
- `name` (string, required)
- `parentId` (string, required, nullable) — Parent model object ID, null for the root level model object
- `status` (enum, required)
  - Allowed values: `deprecated`, `future`, `live`, `removed`
- `tagIds` (list of string, required) — Tag IDs assigned to this model
- `teamIds` (list of string, required) — Team IDs that own this model object, does not propergate up or down
- `teamOnlyEditing` (boolean, required) — Model object (+child diagram, diagram groups and flows) can only be edited by owners and admins
- `technologyIds` (list of string, required) — Technology IDs assigned to this model
- `type` (enum, required)
  - Allowed values: `actor`, `app`, `component`, `group`, `root`, `store`, `system`
- `domainId` (string, required)
- `handleId` (string, required)
- `childDiagramIds` (list of string, required) — Child diagram IDs
- `childIds` (list of string, required) — Child model object IDs, only one level down
- `createdAt` (datetime, required)
- `createdBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `createdById` (string, required)
- `diagrams` (map from string to ModelObjectDiagram, required)
- `flows` (map from string to ModelObjectFlow, required)
- `id` (string, required)
- `landscapeId` (string, required)
- `linked` (boolean, required)
- `parentIds` (list of string, required) — Parent model object IDs for the whole hierarchy, ending with the root model object
- `updatedAt` (datetime, required)
- `updatedBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `updatedById` (string, required)
- `version` (double, required)
- `versionId` (string, required)
- `caption` (string, optional) — Short summary of the object shown as the display description
- `description` (string, optional)
- `deletedAt` (datetime, optional)
- `deletedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `deletedById` (string, optional)
- `latestEntityId` (string, optional)

### ModelConnection

- `commit` (double, required)
- `direction` (enum, required, nullable)
  - Allowed values: `outgoing`, `bidirectional`
- `labels` (map from string to string, required)
- `links` (map from string to RealityLink, required)
- `name` (string, required)
- `originId` (string, required) — Model object that initiates the connection
- `status` (enum, required)
  - Allowed values: `deprecated`, `future`, `live`, `removed`
- `tagIds` (list of string, required) — Tag IDs assigned to this model
- `targetId` (string, required) — Model object that receives the message
- `technologyIds` (list of string, required) — Technology IDs assigned to this model
- `viaId` (string, required, nullable) — Model object that facilitates the connection, such as a Kafka topic, or RabbitMQ queue
- `handleId` (string, required)
- `createdAt` (datetime, required)
- `createdBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `createdById` (string, required)
- `diagrams` (map from string to ModelConnectionDiagram, required)
- `flows` (map from string to ModelConnectionFlow, required)
- `id` (string, required)
- `landscapeId` (string, required)
- `linked` (boolean, required)
- `updatedAt` (datetime, required)
- `updatedBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `updatedById` (string, required)
- `version` (double, required)
- `versionId` (string, required)
- `description` (string, optional)
- `deletedAt` (datetime, optional)
- `deletedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `deletedById` (string, optional)
- `latestEntityId` (string, optional)

### Diagram

- `commit` (double, required)
- `groupId` (string, required, nullable)
- `index` (double, required)
- `labels` (map from string to string, required)
- `modelId` (string, required) — model object id this object belongs to
- `name` (string, required)
- `parentId` (string, required, nullable)
- `pinned` (boolean, required)
- `status` (enum, required)
  - Allowed values: `current`
- `handleId` (string, required)
- `type` (enum, required)
  - Allowed values: `app-diagram`, `component-diagram`, `context-diagram`
- `commentCount` (double, required)
- `connectionCount` (double, required)
- `createdAt` (datetime, required)
- `createdBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `createdById` (string, required)
- `id` (string, required)
- `landscapeId` (string, required)
- `objectCount` (DiagramObjectCount, required) — The number of objects on the diagram, counted by object type and shape
- `updatedAt` (datetime, required)
- `updatedBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `updatedById` (string, required)
- `version` (double, required)
- `versionId` (string, required)
- `description` (string, optional)
- `pinnedAt` (datetime, optional)
- `pinnedIndex` (double, optional)
- `zoomOverrides` (map from string to string, optional, nullable) — Custom zoom levels for specific model objects within the diagram. The key is the modelObjectId and the value is the diagram id.
- `deletedAt` (datetime, optional)
- `deletedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `deletedById` (string, optional)
- `latestEntityId` (string, optional)

### Flow

- `commit` (double, required)
- `index` (double, required)
- `labels` (map from string to string, required)
- `name` (string, required)
- `pinned` (boolean, required)
- `showAllSteps` (boolean, required)
- `showConnectionNames` (boolean, required)
- `steps` (map from string to FlowStep, required)
- `diagramId` (string, required)
- `handleId` (string, required)
- `createdAt` (datetime, required)
- `createdBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `createdById` (string, required)
- `id` (string, required)
- `landscapeId` (string, required)
- `updatedAt` (datetime, required)
- `updatedBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `updatedById` (string, required)
- `version` (double, required)
- `versionId` (string, required)
- `pinnedAt` (datetime, optional)
- `pinnedIndex` (double, optional)
- `deletedAt` (datetime, optional)
- `deletedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `deletedById` (string, optional)
- `latestEntityId` (string, optional)
- `viewedAt` (datetime, optional)
- `viewedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `viewedById` (string, optional)

### ModelObjectIcon

- `catalogTechnologyId` (string, required)
- `name` (string, required)
- `urlDark` (string, optional) — Icon that only works on dark backgrounds
- `urlLight` (string, optional) — Icon that only works on light backgrounds
- `url` (string, optional, deprecated) — Use either urlDark or urlLight

### RealityLink

- `index` (double, required)
- `id` (string, required) — Random 20 character identifier
- `connectionResolveUrl` (string, optional) — Resolve the connector from a publicly accessible URL
- `connector` (RealityConnector, optional) — Links this to a resource in reality, if set periodic checks are performed and the status is updated
- `customName` (string, optional, nullable) — Friendly name for the link set by the user
- `url` (string, optional) — URL pointing to the resource in reality, resolved from the last sync
- `errorMessage` (string, optional) — Error message that was received during the last sync
- `name` (string, optional) — Friendly name describing the resource in reality, resolved from the last sync
- `status` (enum, optional) — Response that was received from the last sync with reality
  - Allowed values: `valid`, `invalid`

### ModelObjectDiagram

- `id` (string, required)
- `objectId` (string, required)

### ModelObjectFlow

- `id` (string, required)
- `stepId` (string, required)

### ModelConnectionDiagram

- `connectionId` (string, required)
- `id` (string, required)
- `originModelId` (string, required)
- `targetModelId` (string, required)

### ModelConnectionFlow

- `id` (string, required)
- `stepId` (string, required)

### DiagramObjectCount

The number of objects on the diagram, counted by object type and shape

- `actor` (double, required)
- `app` (double, required)
- `component` (double, required)
- `group` (double, required)
- `store` (double, required)
- `system` (double, required)
- `area` (double, required)
- `box` (double, required)

### FlowStep

- `description` (string, required) — Descriptive name for the flow step
- `flowId` (string, required, nullable)
- `id` (string, required)
- `index` (double, required)
- `originId` (string, required, nullable)
- `parentId` (string, required, nullable)
- `paths` (map from string to FlowStepPath, required, nullable)
- `targetId` (string, required, nullable)
- `type` (enum, required, nullable) — Type of flow step - deprecated values: reply
  - Allowed values: `alternate-path`, `subflow`, `outgoing`, `parallel-path`, `reply`, `self-action`, `introduction`, `information`, `conclusion`
- `viaId` (string, required, nullable)
- `detailedDescription` (string, optional) — Long description for the flow step

### RealityConnector

- RealityConnectorUrl
- RealityConnectorAzureDevopsRepo
- RealityConnectorAzureDevopsBranch
- RealityConnectorAzureDevopsFolder
- RealityConnectorAzureDevopsFile
- RealityConnectorBitbucketRepo
- RealityConnectorBitbucketBranch
- RealityConnectorBitbucketFolder
- RealityConnectorBitbucketFile
- RealityConnectorBitbucketServerRepo
- RealityConnectorBitbucketServerBranch
- RealityConnectorBitbucketServerFolder
- RealityConnectorBitbucketServerFile
- RealityConnectorGithubRepo
- RealityConnectorGithubBranch
- RealityConnectorGithubFolder
- RealityConnectorGithubFile
- RealityConnectorGitlabRepo
- RealityConnectorGitlabBranch
- RealityConnectorGitlabFolder
- RealityConnectorGitlabFile

### FlowStepPath

- `id` (string, required)
- `index` (double, required)
- `name` (string, required)

### RealityConnectorUrl

- `type` (enum, required)
  - Allowed values: `url`
- `url` (string, required)

### RealityConnectorAzureDevopsRepo

- `accountName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-repo`

### RealityConnectorAzureDevopsBranch

- `accountName` (string, required)
- `branchName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-branch`

### RealityConnectorAzureDevopsFolder

- `accountName` (string, required)
- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-folder`

### RealityConnectorAzureDevopsFile

- `accountName` (string, required)
- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-file`

### RealityConnectorBitbucketRepo

- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-repo`
- `workspaceId` (string, required)

### RealityConnectorBitbucketBranch

- `branchName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-branch`
- `workspaceId` (string, required)

### RealityConnectorBitbucketFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-folder`
- `workspaceId` (string, required)

### RealityConnectorBitbucketFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-file`
- `workspaceId` (string, required)

### RealityConnectorBitbucketServerRepo

- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-repo`

### RealityConnectorBitbucketServerBranch

- `branchName` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-branch`

### RealityConnectorBitbucketServerFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-folder`

### RealityConnectorBitbucketServerFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-file`

### RealityConnectorGithubRepo

- `ownerId` (double, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-repo`

### RealityConnectorGithubBranch

- `branchName` (string, required)
- `ownerId` (double, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-branch`

### RealityConnectorGithubFolder

- `branchName` (string, required)
- `ownerId` (double, required)
- `path` (string, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-folder`

### RealityConnectorGithubFile

- `branchName` (string, required)
- `ownerId` (double, required)
- `path` (string, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-file`

### RealityConnectorGitlabRepo

- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-repo`

### RealityConnectorGitlabBranch

- `branchName` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-branch`

### RealityConnectorGitlabFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-folder`

### RealityConnectorGitlabFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-file`

## Examples

**Response**

```json
{
  "results": [
    {
      "id": "string",
      "name": "string",
      "score": 1.1,
      "type": "actor",
      "data": {
        "caption": "string",
        "commit": 1.1,
        "description": "string",
        "external": true,
        "groupIds": [
          "string"
        ],
        "icon": {
          "catalogTechnologyId": "string",
          "name": "string",
          "url": "string",
          "urlDark": [
            "/organizations/{organizationId}/dark/{catalogTechnologyId}.png",
            "/dark/{catalogTechnologyId}.png"
          ],
          "urlLight": [
            "/organizations/{organizationId}/light/{catalogTechnologyId}.png",
            "/light/{catalogTechnologyId}.png"
          ]
        },
        "labels": {},
        "links": {},
        "name": "string",
        "parentId": "string",
        "status": "deprecated",
        "tagIds": [
          "string"
        ],
        "teamIds": [
          "string"
        ],
        "teamOnlyEditing": true,
        "technologyIds": [
          "string"
        ],
        "type": "actor",
        "domainId": "string",
        "handleId": "string",
        "childDiagramIds": [
          "string"
        ],
        "childIds": [
          "string"
        ],
        "createdAt": "2024-01-15T09:30:00Z",
        "createdBy": "user",
        "createdById": "string",
        "deletedAt": "2024-01-15T09:30:00Z",
        "deletedBy": "user",
        "deletedById": "string",
        "diagrams": {},
        "flows": {},
        "id": "string",
        "landscapeId": "string",
        "latestEntityId": "string",
        "linked": true,
        "parentIds": [
          "string"
        ],
        "updatedAt": "2024-01-15T09:30:00Z",
        "updatedBy": "user",
        "updatedById": "string",
        "version": 1.1,
        "versionId": "string"
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/search"

querystring = {"search":"search"}

headers = {"X-API-Key": "<apiKey>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/search?search=search"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-API-Key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```csharp
using RestSharp;

var client = new RestClient("https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/search?search=search");
var request = new RestRequest(Method.GET);
request.AddHeader("X-API-Key", "<apiKey>");
IRestResponse response = client.Execute(request);
```